<?php

namespace Drupal\entity_manager\Form;

use Drupal\Core\Form\ConfigFormBase;
use Drupal\Core\Form\FormStateInterface;

/**
 * Configure Entity Manager settings for this site.
 */
class SettingsForm extends ConfigFormBase
{

    /**
     * {@inheritdoc}
     */
    public function getFormId()
    {
        return 'entity_manager_settings';
    }

    /**
     * {@inheritdoc}
     */
    protected function getEditableConfigNames()
    {
        return ['entity_manager.settings'];
    }

    /**
     * {@inheritdoc}
     */
    public function buildForm(array $form, FormStateInterface $form_state)
    {
        $form['example'] = [
        '#type' => 'textfield',
        '#title' => $this->t('Example'),
        '#default_value' => $this->config('entity_manager.settings')->get('example'),
        ];
        return parent::buildForm($form, $form_state);
    }

    /**
     * {@inheritdoc}
     */
    public function validateForm(array &$form, FormStateInterface $form_state)
    {
        if ($form_state->getValue('example') != 'example') {
            $form_state->setErrorByName('example', $this->t('The value is not correct.'));
        }
        parent::validateForm($form, $form_state);
    }

    /**
     * {@inheritdoc}
     */
    public function submitForm(array &$form, FormStateInterface $form_state)
    {
        $this->config('entity_manager.settings')
            ->set('example', $form_state->getValue('example'))
            ->save();
        parent::submitForm($form, $form_state);
    }

}
